#!/bin/bash

#################################################################################
# This scripts finds the IP address of a machine according to its MAC address.
# The scripts scans the 256 IP addresses close to the IP in the first parameter
# and prints out the IP address that matches the MAC address in the second 
# parameter.
# If the base address for the scan is 192.168.0.X then the scan will run through
# address 192.168.0.0-192.168.0.255
#
# Parameters:
#	$1 - IP address that is the base for the scan.
#	$2 - MAC addresses to look for, separated by a semicolon (actual separator
#			is not important.
#
##################################################################################
nmap --stylesheet /opt/gs-files/ipFromMac.xslt  -oX nmap_results.xml  -sP -n $1/24 > /dev/null
xsltproc --stringparam addr "$2" nmap_results.xml

